/* @(#)system.c	4.1 (Berkeley) 12/21/80 */
#include	<signal.h>
#include <string.h>

#ifndef NULL
#  define NULL 0
#endif /* NULL */

extern int errno;

cshsystem(s)
char *s;
{
	int status, pid, w;
/*	char *shell, *getshell();	/* figure out users shell */
	char *shell;
	char *tail;

	shell = "/bin/csh";
	/** shell = getshell(); **/
	tail = strrchr(shell, '/');
	if (tail != (char *)NULL) {
		tail++;
	}

	if ((pid = fork()) == 0) {
		execl("/bin/csh", "csh", "-c", s, 0);
		/**execl(shell, (tail == NULL) ? shell : tail, "-c", s, 0);*/
		perror("cshsystem -- execl failed");
		_exit(errno);
	}

	if (pid == -1) {
		perror("cshsystem -- fork failed");
		_exit(errno);
	}

#if defined(HAVE_TERMIOS_H)
	signal(SIGINT, SIG_IGN);
	signal(SIGQUIT, SIG_IGN);
	while ((w = wait(&status)) != pid && w != -1)
		;
	if (w == -1)
		status = -1;
	signal(SIGINT, SIG_DFL);
	signal(SIGQUIT, SIG_DFL);
#else /* NOT defined(HAVE_TERMIOS_H) */
	{
		register int (*istat)(), (*qstat)();
		istat = signal(SIGINT, SIG_IGN);
		qstat = signal(SIGQUIT, SIG_IGN);
		while ((w = wait(&status)) != pid && w != -1)
				;
		if (w == -1)
				status = -1;
		signal(SIGINT, istat);
		signal(SIGQUIT, qstat);
	}
#endif /* defined(HAVE_TERMIOS_H) */
	return(status);
}
